#!/usr/local/bin/perl

$startdir = $ARGV[0];

if (!defined($startdir)) {
  $startdir = `pwd`;
  chop($startdir);
}

&traverse($startdir);
exit(0);

sub traverse {
  local($dir) = @_;
  local(*DIR);
  local(@dircache);

  opendir(DIR, $dir);
  local(@dir) = grep (!/^\.\.?$/,readdir(DIR));
  closedir(DIR);

  foreach $d (@dir) {
    ($mode, $uid, $gid) = (lstat("$dir/$d"))[2,4,5];
    
    if (-d _) {
      push(@dircache, $d);
      next;
    }

    next if (! -f _);

    ($names{$uid}) = getpwuid($uid) if ! defined $names{$uid};
    $oname = $names{$uid};
    ($groups{$gid}) = getgrgid($gid) if ! defined $groups{$gid};
    $gname = $groups{$gid};
    
    $mode = $mode & 0007777;

    # just in case, handle unknown users/groups
    $oname = "root" if ($oname eq "");
    #or common translations
    $gname = "wheel" if ($gname eq "" || $gname eq "staff");

    if ((-u _) || (-g _)) {
      print "$dir/$d \t$oname $gname ";
      printf "%lo\n", $mode;
    }
  }
  foreach (@dircache) {
    &traverse("$dir/$_");
  }
  @dircache=();
}

