#!/usr/local/bin/perl

$debug = 0;
$doing_devices = 0;
$config_file = '/afs/andrew.cmu.edu/wsadmin/support/pckg/pckg.generic';
require 'ctime.pl';

while ($ARGV[0] =~ /^-/) {
  if ($ARGV[0] eq "-d") {
    $debug = 1;
  } elsif ($ARGV[0] eq "-f") {
    shift @ARGV;
    $config_file = $ARGV[0];
  } elsif ($ARGV[0] eq "-s") {
    shift @ARGV;
    $sys = $ARGV[0];
  } elsif ($ARGV[0] eq "-l") {
    $light = 1;
  } else {
    &usage();
  }
  shift @ARGV;
}

&usage()
  if (@ARGV != 1);

($os_tree, $start_dir) = $ARGV[0] =~ /(.*os)(.*$)/;

if (! defined $sys) {
  $sys = `sys` ;
  chop($sys);
}

if (defined $os_tree) { 
  if ($os_tree =~ /\/nos$/) {
    $os_tree = "$os_tree/$start_dir";
    $start_dir = '';
  }
} else {
  $os_tree = "";
  $start_dir = $ARGV[0];
}

chop($start_dir)
    if ($start_dir =~ /.*\/$/);

&init();

$light = 1 if $lightlist{$start_dir};

&traverse($start_dir, $light, 0);

exit(0);

sub 
printline {
  local($type, $file, $rfile, $owner, $group, $mode, $wrap) = @_;
  
  lstat($file);

  unless (-l _)
  {
    print "chown $owner $file\nchgrp $group $file\n";
    print "chmod ";
    printf "%lo" ,$mode;
    print " $file\n";
  }
}


#
sub 
traverse {
  local($dir, $light, $absolute)=@_;
  local($d);
  local(%inoar) = ();
  local(@dircache) = ();
  local(@filecache) = ();
  local(@linkcache) = ();
  local(@devcache) = ();
  local(*DIR);
  local($file, $rfile);
  
  $rdir= $os_tree . $dir;

  opendir(DIR, $rdir) || die "Can't open directory $rdir: $!\n";
  local(@dir) = grep (!/^\.\.?$/,readdir(DIR));
  closedir(DIR);
  
  foreach $d (@dir) {
    $file = "$dir/$d";
    $rfile = "$os_tree$file";

    ($ino, $mode, $nlink,$uid, $gid, $rdev) = (lstat($rfile))[1,2,3,4,5,6];

    $names{$uid} = $usermap{$uid} if (defined $usermap{$uid} && !defined $names{$uid});
    ($names{$uid}) = getpwuid($uid) if ! defined $names{$uid};
    $oname = $names{$uid};
    $groups{$gid} = $groupmap{$gid} if (defined $groupmap{$gid} && !defined $groups{$gid});
    ($groups{$gid}) = getgrgid($gid) if ! defined $groups{$gid};
    $gname = $groups{$gid};
    
    $mode = $mode & 0007777;
    
    # just in case, handle unknown users/groups
    $oname = "root" if (! defined($oname));
    
    #or common translations
    $gname = "wheel" if (! defined $gname || $gname eq "staff");
    
    # symlinks
    if (-l _) {
      $link = readlink($rfile);
      
      local(@linkar) = split(/\//, $link);
      
      # don't do anything with an absolute link
      if ($linkar[0] ne "") {
	$up = 0;
	# rip off "." and ".." counting ".."s in $up
	while (1) {
	  # link to ./something - rip off ./
	  if ($linkar[0] eq ".") {
	    shift(@linkar);
	    next;
	  }
	  if ($linkar[0] eq "..") {
	    shift(@linkar);
	    $up++;
	    next;
	  }
	  #drop out when we have no .|..
	  last;
	}
	
	local(@dirar) = split(/\//, $dir);
	while ($up--) {
	  #rip from bottom this time
	  pop(@dirar);
	}
	
	$link = join('/', @dirar, @linkar);
	if ($#dirar == -1) {
	  #link went above /. odd, but legal
	  $link = "/$link";
	}
      }
      push(@linkcache, join($;,$file,$link,$oname,$gname,$mode));
      next;
    }
    
    # make hard links into symbolic links 
    # (package can not do hard links - sigh)
    if (defined $inoar{$ino}) {
      $inoar{$ino} = join('\\', $inoar{$ino},
			  join($;, $file, $oname, $gname, $mode));
      next;
    }

    # cache directory entries do we do not get huge %inoar wastage
    if (-d _) {
      push(@dircache, join($;, $file, $oname, 
			   $gname, $mode));
      next;
    }

    # has hard links to it
    if ($nlink > 1) {
      print STDERR "WARNING: Hard link detected for file $file.\n";
      print STDERR "         You should run soften.pl before running pckg.\n";
      $inoar{$ino} = $file;
    }
    
    # normal files
    if (-f _) {
      push(@filecache, join($;, $file, $oname, $gname, $mode));
      next;
    } 
    # device entry
    if (-b _ || -c _) {
      # some systems use longwords - detect
      if ($sys eq "hp700_ux90") {
	$major_dev = (($rdev >> 24)& 0x000000ff); # 8 bit major
	$minor_dev = $rdev & 0x00ffffff;    # 24 bit minors
      } else {
	if ($rdev & 0xffff0000) {
	  $major_dev = ($rdev >> 16) & 0x0000ffff;
	  $minor_dev = ($rdev) & 0x0000ffff;
	} else {
	  $major_dev = ($rdev >> 8) & 0x000000ff;
	  $minor_dev = ($rdev) & 0x000000ff;
	}
      }
      if (-b _) {
	$type = "B";
      } else {
	$type = "C";
      }
      push(@devcache, join($;,$type, $file, 
			    $major_dev, $minor_dev, 
			    $oname, $gname, $mode));
      next;
    }
  }				# end of for loop for files

  # emit hard link translations
  for (sort values %inoar) {
    ($prime, @sub) = split(/\\/);
    for (sort @sub) {
      ($file, $oname, $gname, $mode) = split(/$;/);
      push(@linkcache, join($;, $file, 
			    $prime, $oname, $gname, $mode));
    }
  }

  %inoar = ();

# --- output the lines
  # symlinks 
  foreach (sort @linkcache) {
    ($file, $link, $oname, $gname, $mode) = split(/$;/);
    &printline("LA", $file, $link, $oname, $gname, $mode, 1);
  }

  # files 
  foreach (sort @filecache) {
    local($ftype);
    ($file, $oname, $gname, $mode) = split(/$;/);

    # yuck... doing this manually...
    if ($rebootlist{$file}) {
      $ftype = 'FOQ';
    } else {
      $ftype = 'F';
    }

    &printline($ftype, $file, '${machine}',$oname, $gname, $mode,1);
  }

  # devices
  foreach (sort @devcache) {
    ($type, $file, $major_dev, $minor_dev, $oname, $gname, $mode) = split(/$;/);
    &printline($type, $file, "$major_dev $minor_dev", $oname, $gname, $mode, 1);
  }
  
  #  directories
  for (sort @dircache) {
    ($file, $oname, $gname, $mode) = split(/$;/);

    &printline("DR", $file, '', $oname, $gname, $mode,0);
    &traverse($file, $light);
  }
  
  # clear directory cache
  @dircache = ();
}


sub
init {

# don't buffer stdout
  select(STDOUT);
  $| = 1;
  
  system("mpp -Dsys=$sys -D$sys $config_file > /tmp/pckg.$$");
  die "error running mpp: rc = $?\n"
    if ($? != 0);

  &parse("/tmp/pckg.$$");
  unlink("/tmp/pckg.$$")
   unless ($debug); 
}

sub 
usage {
  print "usage: pckg [-d] [-f config_file] directory\n";
  print "\t-d\tEnable debugging mode.\n";
  print "\t-f\tSpecify an alternate configuration file.\n";
  print "\t-s\tSpecify an alternate system type.\n";
  exit 1;
}

sub parse {
    local($file) = @_;
    local(%valid) = ("rebootlist", 1, "permlist", 1, "prunelist", 1, "securelist", 1, "lightlist", 1, "usermap", 1, "groupmap", 1);
    local($curhash);
    local(*FD);
    local($line) = (0);

    open(FD, "<$file") || die "Error opening file: $file: $!\n";

    undef $curhash;

    while (<FD>) {
	$line++;
	s/\#.*$//;
	next if /^\s*$/;
	s/^\s*$//;

	if (/^BEGIN\s+(\S+)/) {
	    die "Error: $1 is an unknown list name (line $line)\n" if (! $valid{$1});
	    $curhash = $1;
	    next;
	}
	elsif (/^END/) {
	    undef $curhash;
	    next;
	}
	
	@ar = $_ =~ /(\S+)\s*(.*)$/;

	die "Error: unbound value $ar[0] (line $line)\n" if !defined $curhash;

	if (length($ar[1])) {
	    eval '$' . $curhash . "{'$ar[0]'} = '$ar[1]'";
	} else {
	    # no explicit value
	    eval '$' . $curhash . "{'$ar[0]'} = 1";
	}
    }

    die "Error: config not terminated by END\n" if defined $curhash;
}

