#!/usr/local/bin/perl -w
# 
# gendisk-config.perl -- genereate the disk-config.${sys} files from tree.${sys}
# 
# usage: gendisk-config.perl tree.${sys} > disk-config.${sys}
#
# note that we assume that the 'sys' variable is the string that follows
#      "tree." in the argument list.
#
# $Header: /afs/andrew.cmu.edu/system/src/host/pkgtools/002/RCS/gendisk-config.pl,v 1.1 1994/03/28 19:47:04 ww0r Exp wcw $

die("usage: gendisk-config.perl tree.\${sys} > disk-config-base.\${sys}\n")
    unless (@ARGV == 1);

require "ctime.pl";

@tmp = split(/\./, $ARGV[0]);
$sys = $tmp[$[ + $#tmp];
$wsadmin='${wsadmin}'; # to keep the warning messages from showing up

open(TREE, "$ARGV[0]") || die("$0: unable to open file \"$ARGV[0]\".\n");

$nDR = 0;
while (<TREE>) {
  next 
    unless (/^\s*\$\{cp/);
  ($path) = (split(/\s+/))[1];
  $DR{$nDR++} = $path;
}
print "## BEGIN ${wsadmin}/lib/sys/disk-config-base.${sys}\n";
print '## This file is automatically generated by gendisk-config.pl $Id$ on ', &ctime(time);
print "## DO NOT EDIT\n";

$c = 0;
while ( $c < $nDR) {
  print "%ifndef nocp$DR{$c}\n";
  print "%ifndef\tcp$DR{$c}\n";
  printf "%%\tdefine\t\tcp%-25s\t\${typeDR}\n", $DR{$c++};
  print "%endif\n";
  print "%endif\n";
}
print "%ifdef\tcomment_block\n";
print "## The following lines summarize all of the directories\n";
print "## Note that defining a directory higher up in the chain to be DR'd or L'd\n";
print "## automatically gets rid of any directory lower in the hierarchy.\n";

$c = 0;
while ( $c < $nDR) {
    printf "%%define\tcp%-25s\t\n", $DR{$c++};
}
print "%endif\tcomment_block\n";
print "\n## END ${wsadmin}/lib/sys/disk-config.${sys}\n";

# end of gendisk-config.pl
