#!/usr/local/bin/perl -w

$debug = 1;


&parse();

sub 
parse {
local($name, $rest);
local($state) = 0;

while (<>) {
    next if /\s*#/;
    next if /^\s*$/;

    if (/^BEGIN/) {
      ($name) = /^\s*BEGIN\s+(.*)/;
      print "BEGIN $name\n"
	if ($debug);
      if ($name eq "rebootlist") {
	$state = 1;
      } elsif ($name eq "prunelist") {
	$state = 2;
      } elsif ($name eq "securelist") {
	$state = 3;
      } else {
	die "Parse Error: Invalid begin name of $name\n";
      }
      next;
    }

    die "Parse Error: Configuration block must begin with a BEGIN statement.\n"
      if ($state == 0);
    
    if (/^END/) {
      ($name) = /^\s*END\s+(.*)/;
      if ($name eq "rebootlist") {
	if ($state == 1) {
	  $state = 0;
	} 
      } elsif ($name eq "prunelist") {
	if ($state == 2) {
	  $state = 0;
	}
      } elsif ($name eq "securelist") {
	if ($state == 3) {
	  $state = 0;
	}
      } else {
	die "Parse Error: Invalid end name of $name\n";
      }

      print "END $name\n"
	if ($debug);

      if ($state != 0) {
	die "Parse Error: End for $name does not match the begin block\n";
      }
      next;      
    }

    chop;
    $_=~ s/^\s*|\s*$//g; # strip leading and trailing white space

    if ($state == 1) {
      $rebootlist{$_} = 1;
      print "Setting rebootlist $_\n"
	if ($debug);
      next;
    } 

    if ($state == 2) {
      $prunelist{$_} = 1;
      print "Setting prunelist = $_\n"
	if ($debug);
      next;
    } 

    if ($state == 3) {
      ($name, $rest)  = split(/\s+/);
      $securelist{$name} = $rest;
      print "Setting securelist $name = $rest\n"
	if ($debug);
      next;
    } 
    die "Parse Error: Shouldn't be able to get to this line.\n";
  }
}











