#!/usr/local/bin/perl
# $Header: /afs/andrew.cmu.edu/system/src/host/pkgtools/001/RCS/test-link.pl,v 1.1 1994/01/11 22:37:57 ww0r Exp $
# --- Verify that the symbolic links point to a real 
#     file.

open(FP, ">/tmp/badlinks") || die "can't open /tmp/badlinks: $!\n";
select(FP); $| = 1;
select(STDOUT);

&traverse($ARGV[0]);
close(FP);
exit(0);

sub
traverse {
  local($cwd) = @_;
  local(*DP);
  local($cpath, $apppath, $linkname);
  local(@plist);

  print "Processing $cwd\n";
  opendir(DP, $cwd) || die "can't open directory $cwd: $!\n";
  foreach (readdir(DP)) {
    next if (/^\.\.?$/);
    $cpath = "$cwd/$_";
    if (-d $cpath) {
      &traverse($cpath);
      next;
    }
    if (-l $cpath) {
      print "Found symlink $cpath. Verifying...";
      ($linkname = readlink($cpath) ) || die "Can't readlink $cpath: $!\n";
      @plist = split(/\//, $cpath);
      pop(@plist);
      $apppath = join('/',@plist);
      $linkname = ($linkname =~ /^\//) ?  $linkname : "$apppath/$linkname";
      if (-r $linkname) {
	print "done.\n";
      } else {
	print "ERROR. Invalid path: $linkname\n\007";
	print FP "Invalid link: $cpath -> $linkname\n";
      }
    }
  }
  closedir(DP);
}



